Unit CMOS;
{
Ŀ
   UNIT CMOS                                                Version 1.50   
      
   Diese Unit zeigt den Zugriff auf die Speicherstellen des Batterie-      
   gepufferten CMOS-RAM.                                                   
      
   (c) 1994 DJ ByteDisaster & BSR-SOFTWAREGroup Sachsen-Anhalt fr PDM     

}
INTERFACE

Function  BCD2Byte(BCDVal : Byte) : Byte;                             {BCDVal in Dezimalzahl umwandeln            }
Function  ReadCMOSByte(index : Byte) : Byte;                          {Liest die Speicherstelle index aus dem CMOS}
Procedure WriteCMOSByte(index,ByteVal : Byte);                        {Schreibt Byteval in CMOS-Adresse index     }
Procedure GetCMOSTime(Var Hour,Min,sec : Byte);                       {Liest die aktuelle Zeit aus dem CMOS       }
Procedure GetCMOSAlarmTime(Var Hour,Min,sec : Byte);                  {Liest die Alarmzeit aus dem CMOS           }
Procedure GetCMOSDate(Var WeekDay,Day,Month : Byte;Var Year : Word);  {Liest das Datum aus dem CMOS               }

IMPLEMENTATION

Function BCD2Byte;ASSEMBLER;
asm
  sub  ah,ah            { AH lschen                        }
  mov  al,bcdval        { BCD-Wert nach AL                  }
  mov  bl,al            { und nach BL                       }
  shr  ax,1             { unteres Nibble durch viermalige   }
  shr  ax,1             { Rechtsverschiebung von AX lschen }
  shr  ax,1             { AL enthlt jetzt das untere Nibble}
  shr  ax,1             { entspricht AL div 16              }
  mov  dx,000Ah         { Multiplikator 10 nach DX          }
  mul  dx               { oberes Nibble in AL mit 10 multip.}
  and  bl,00001111b     { oberes Nibble in BL lschen       }
  add al,bl             { oberes Nibble in AL mit unterem   }
end;                    { Nibble in BL addieren             }
{---------------------------------------------------------------------------}
Function ReadCMOSByte;ASSEMBLER;
asm
  mov  dx,0070h         { Portadresse fr CMOS-Index nach DX                }
  mov  al,index         { Adresse des zu lesenden Bytes nach AL             }
  out  dx,al            { und zum Indexregister schicken                    }
  nop                   { kurze Verzgerung durch zwei NOP-Operationen, um  }
  nop                   { den Prozessor zu entlasten                        }
  inc  dx               { DX erhhen -> DX=Adresse fr CMOS-Datenregister   }
  in  al,dx             { CMOS-Byte nach AL lesen                           }
End;
{---------------------------------------------------------------------------}
Procedure WriteCMOSByte;ASSEMBLER;
asm
  mov  dx,0070h         { Portadresse fr CMOS-Index nach DX                }
  mov  al,index         { Adresse des zu lesenden Bytes nach AL             }
  out  dx,al            { und zum Indexregister schicken                    }
  nop                   { kurze Verzgerung durch zwei NOP-Operationen, um  }
  nop                   { den Prozessor zu entlasten                        }
  inc  dx               { DX erhhen -> DX=Adresse fr CMOS-Datenregister   }
  mov  al,byteval       { zu schreibenden Wert nach AL                      }
  out  dx,al            { Wert in CMOS-Adresse schreiben                    }
End;
{---------------------------------------------------------------------------}
Procedure GetCMOSTime;
Begin
  Hour:=BCD2Byte(ReadCMOSByte($04));
  Min :=BCD2Byte(ReadCMOSByte($02));
  Sec :=BCD2Byte(ReadCMOSByte($00));
End;
{---------------------------------------------------------------------------}
Procedure GetCMOSAlarmTime;
Begin
  Hour:=BCD2Byte(ReadCMOSByte($05));
  Min :=BCD2Byte(ReadCMOSByte($03));
  Sec :=BCD2Byte(ReadCMOSByte($01));
End;
{---------------------------------------------------------------------------}
Procedure GetCMOSDate;
Begin
  WeekDay:=BCD2Byte(ReadCMOSByte($06));
  Day    :=BCD2Byte(ReadCMOSByte($07));
  Month  :=BCD2Byte(ReadCMOSByte($08));
  Year   :=BCD2Byte(ReadCMOSByte($32))*100+
           BCD2Byte(ReadCMOSByte($09));
End;

end. {END OF CMOS.PAS}

(***************************************************************************)
(**                   DISCLAIMER OF WARRANTY                              **)
(**   -----------------------------------------------------------------   **)
(**   Die BSR-SOFTWAREGroup Sachsen-Anhalt bernimmt keinerlei Garantien  **)
(**   irgendeiner Art fr die Verwendbarkeit und/oder Nichtverwendbarkeit **)
(**   der Software fr irgendeinen Zweck. Fr fehlerhafte Angaben/Pro-    **)
(**   grammfehler und deren mittelbare oder unmittelbare Folgen wird      **)
(**   keinerlei Haftung bernommen.                                       **)
(**   -----------------------------------------------------------------   **)
(**   Diese Unit wurde exklusiv als DEMO-Source fr das PDM erstellt, das **)
(**   Urheberrecht verbleibt jedoch im Besitz der BSR-SOFTWAREGroup       **)
(**   Sachsen-Anhalt. Jeder Leser, der das PDM auf legalem Wege ber den  **)
(**   Herausgeber Herrn M. Heuschele bezogen hat, hat das Recht, diese    **)
(**   Unit frei von jeglichen finanziellen Forderungen des Autors in ei-  **)
(**   genen Programmen zu nutzen, sofern diese nicht verndert wird und   **)
(**   die Herkunft des Quelltextes nicht durch Eingriff in denselben      **)
(**   verschleiert wird.                                                  **)
(**   Der gewerbliche Gebrauch der Unit sowie Versandt,Vermietung oder    **)
(**   Verkauf ohne ausdrckliche Genehmigung der Autoren verstt gegen   **)
(**   das Urheberrecht und hat strafrechtliche Folgen.                    **)
(**   -----------------------------------------------------------------   **)
(**   DJ ByteDisaster, BSR-SOFTWAREGroup Sachsen-Anhalt 14.09.1994        **)
(***************************************************************************)
