#include<math.h>
#include<stdio.h>
#include<conio.h>
#include<stdarg.h>
#include<graphics.h>

void Achsenkreuz(void);       
void Achseneinteilung(void);  
void Schaubildzeichnen(void); 
void Ginit(void);             
int gprintf( float xloc, float yloc, char *fmt, ... ); 


//Globale Variablen//
int ax,ay,xko,yko; //ax,ay Eingabeparameter fr die x-  bzw. y-Achse//
		   //Hilfsvariablen, denen spter die max.          //
		   //Bildschirmkoordinaten zugewiesen werden        //

//-------------//
//Hauptprogramm//
//-------------//
void main(void)
{
 Achseneinteilung();
 Schaubildzeichnen();
 getch();
 closegraph();
}

//-----------------------------------------------//
//Funktion Achsenkreuz - zeichnet das Achsenkreuz//
//-----------------------------------------------//
void Achsenkreuz(void)
{
 setbkcolor(LIGHTGRAY);          //Hintergrundfarbe HELLGRAU//
 setcolor(BLUE);
 line(xko/2,0,xko/2,yko);     //y-Achse in der Mitte des Bilsschirmes//
 line(0,yko/2,xko,yko/2);     //x-Achse in der Mitte des Bilsschirmes//

 outtextxy(xko-11,yko/2+30,"x");  // Achsenbezeichnung //
 outtextxy(xko/2-30,11,"y");      //      -"-          //

 // PFEIL MITTE RECHTS //
 line(xko,yko/2,xko-12,yko/2-3);
 line(xko,yko/2,xko-12,yko/2+3);
 line(xko-12,yko/2-3,xko-12,yko/2+3);
 floodfill(xko-9,yko/2+1,BLUE);
 floodfill(xko-9,yko/2-1,BLUE);

 // PFEIL MITTE OBEN //
 line(xko/2,0,xko/2-3,12);
 line(xko/2,0,xko/2+3,12);
 line(xko/2-3,12,xko/2+3,12);
 floodfill(xko/2-1,9,BLUE);
 floodfill(xko/2+1,9,BLUE);
}

//-------------------------------------------------------------//
//Funktion zur Eingabeparameterabhngigen Einteilung der Achsen//
//-------------------------------------------------------------//
void Achseneinteilung(void)
{
 clrscr();
 int i,z=0,fx,fy;                  //i,z:Zhlvariablen                 //
				   //fx,fx: Faktoren die von ax und ay //
				   //abhngig sind                     //

 printf("\nEinteilung x-Achse:");  //Hier wird praktisch die Intevallgrenze//
 scanf("%i",&ax);                  //fr die x bzw. y Achse eingelesen     //
 printf("\nEinteilung y-Achse:");  //und in ax(ay) gespeichert             //
 scanf("%i",&ay);

 if (ax > 0 && ax <= 10) fx=1;     //Hier werden dir Faktoren in      //
 if (ax > 10 && ax <= 30) fx=2;    //Abhngigkeit von ax,ay bestimmt  //
 if (ax > 30 && ax <= 50) fx=5;
 if (ay > 0 && ay <= 10) fy=1;
 if (ay > 10 && ay <= 30) fy=2;
 if (ay > 30 && ay <= 50) fy=5;

 Ginit();                          //Graphikmodus initialisieren//
 xko=getmaxx();
 yko=getmaxy();
 Achsenkreuz();

 for(i=0;i<=xko/2;i=i+(xko/2/ax)*fx)        // "Beschriftung" der Achsen //
 {
  line(xko/2-i,yko/2+5,xko/2-i,yko/2-5);
  line(xko/2+i,yko/2+5,xko/2+i,yko/2-5);
  if(z!=0 )
  {
   gprintf(xko/2+i-3,yko/2+15,"%i",z*fx);
   gprintf(xko/2-i-10,yko/2+15,"%i",z*fx*-1);
  }
  z++;
 }
 z=0;
 for(i=0;i<=yko/2;i=i+(yko/2/ay)*fy)
 {
  line(xko/2-5,yko/2+i,xko/2+5,yko/2+i);
  line(xko/2+5,yko/2-i,xko/2-5,yko/2-i);
  if(z!=0)
  {
   gprintf(xko/2-20,yko/2-i-4,"%i",z*fy);
   gprintf(xko/2-30,yko/2+i-3,"%i",z*-1*fy);
  }
  z++;
 }
}

//-----------------------------------------------------------------//
// Funktion zur eigentlichen Ausgabe des Graphen auf den Bildschirm//
//-----------------------------------------------------------------//
//nhere Erklrungen im Artikel//
void Schaubildzeichnen(void)
{
 double x,y,xb,yb;   //y,x:Funktionswerte;xb,yb:Bildschirmkoordinaten, die //
		     //die mit Hilfe von x,y ins kartesische Bildschirm-   //	
		     //koordinatensystem umgewandelt werden                //
 int mx,my;          //mx,my:Faktor, der zur                               //
		     //Umwandlung der Funktionswerte in kart. Koordinaten  //
		     //bentigt werden und den Intervallgrenzen(ax,ay)     //
		     //abhngig sind  					   //		
 setcolor(RED);
 yb=yko/2;
 mx=xko/(ax+ax);       
 my=yko/(ay+ay);

 for(xb = 0; xb <= xko; xb++)
 {
  moveto(xb,yb);
  x = (xb - xko/2)/mx;
  if(x != 0)           //Division durch Null ausschlieen//
  y=pow(x,3)+2*x*x;    // Hier knnen auch andere Funktionsgleichungen
		       // eingesetzt werden//
  yb = yko/2 - y*my;
  if(yb >= 0 && yb <= yko)
    {
   lineto(xb,yb);
  }
 }
}

void Ginit(void)
{
 int gdriver = DETECT,gmode;
 initgraph(&gdriver,&gmode,"\\tc\\bgi\\");
}

int gprintf( float xloc, float yloc, char *fmt, ... )
{
  va_list  argptr;                      /* Argument list pointer        */
  char str[140];                        /* Buffer to build sting into   */
  int cnt;                              /* Result of SPRINTF for return */

  va_start( argptr, fmt );              /* Initialize va_ functions     */

  cnt = vsprintf( str, fmt, argptr );   /* prints string to buffer      */
  outtextxy(xloc,yloc, str );       /* Send string in graphics mode */
  va_end( argptr );                     /* Close va_ functions          */

  return( cnt );                        /* Return the conversion count  */

}
