.386
.model small
screen segment at 0a000h
.data   
        Help1 sword 0
        Help2 sword 0
        Help3 sword 0
        Help4 sword 0
        Help5 sword 0
.code
assume es:screen 
Start:

; ***************************************************************************
; Titel       : SetGrafMode1          
;
; Beschreibung: Schaltet die VGA-Karte in die Auflsung 320*200-256
;
; Ergebniss   : AX enthlt 0013h = aktueller Modus, bei korrekter Ausfhrung
;
; Seiteneffekt: keiner
;
        SetGrafMode1 proc
                     mov ax,0013h    ; Funktionsnummer und Modus nach AX
                     int 10h         ; und Interrupt 10h aufrufen.
                     ret             ; Rcksprung.
        SetGrafMode1 endp 
;
; ***************************************************************************
; Titel       : SetPoint          
;
; Beschreibung: Setzt ein Pixel in der Auflsung 320*200-256
;
; Aufruf      : AX = XPos
;               BX = YPos
;               CL = Farbe
;
; Ergebniss   : keines
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;
        SetPoint     proc uses di               
                     imul di,bx,320     ; Index berechnen, 
                     add di,ax          ; Ergebniss steht in DI.
                     mov screen:[di],cl ; Farbe an Adresse speichern.
                     ret                ; Rcksprung.
        SetPoint     endp
;
; ***************************************************************************
; Titel       : GetPoint          
;
; Beschreibung: Liest die Farbe eines Pixels in der Auflsung 320*200-256
;
; Aufruf      : AX = XPos
;               BX = YPos
;
; Ergebniss   : CL = Farbwert
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;
         GetPoint    proc uses di   
                     imul di,bx,320     ; Index berechnen,
                     add di,ax          ; Ergebniss steht in DI.
                     mov cl,screen:[di] ; Farbwert in CL speichern.
                     ret                ; Rcksprung.
         GetPoint    endp
;
; ***************************************************************************
; Titel       : FillScreen          
;
; Beschreibung: Lscht bzw. fllt den Bildschirm in der Auflsung 320*200-256
;
; Aufruf      : DL = Farbe
;
; Ergebniss   : keines
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;
        FillScreen   proc uses eax cx dx di               
                     mov dh,dl          ; Farbe nach DH kopieren.
                     mov ax,dx          ; Farbe nach AX kopieren.
                     rol eax,16         ; Farbe nach EAX verschieben.
                     mov ax,dx          ; Farbe nach AX kopieren.
                     mov cx,16000       ; Schleifenanzahl laden.
                     xor di,di          ; Index festlegen.
                     rep stosd          ; Schleife bis CX = 0.
                     ret                ; Rcksprung.
        FillScreen   endp
;
; ***************************************************************************
; Titel       : FillBox          
;
; Beschreibung: Lscht bzw. fllt einen rechteckigen Bildschirmausschnitt,
;               in der Auflsung 320*200-256
;
; Aufruf      : AL = Farbe
;               BX = XPos
;               CX = Lnge 
;               DX = YPos 
;               SI = Breite
;
; Ergebniss   : keines
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;               Startpunkt zhlt bei Lnge/Breite mit
;
        FillBox      proc uses si di
                     imul di,dx,320     ; Index berechnen, Ergebniss
                     add di,bx          ; steht in DI
                FB1: push cx            ; Lnge x zwischenspeichern.
                     push di            ; Index zwischenspeichern.
                     rep stosb          ; Punkte setzen, bis Lnge x erreicht.
                     pop di             ; Index wieder laden.
                     pop cx             ; Lnge x wieder laden.
                     add di,320         ; XPos eine Zeile erhhen und prfen
                     dec si             ; ob alle Zeilen gefllt wurden.
                     jne FB1            ; Wenn nicht, nchste y-Zeile fllen.
                     ret                ; Rcksprung.
        FillBox      endp
;
; ***************************************************************************
; Titel       : HoLine          
;
; Beschreibung: Zeichnet eine horizontale Linie in der Auflsung 320*200-256
;
; Aufruf      : AL = Farbe
;               BX = XPos
;               CX = relative Lnge
;               DX = YPos
;
; Ergebniss   : keines
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;
        HoLine       proc uses cx di      
                     imul di,dx,320     ; Index berechnen,
                     add di,bx          ; Ergebniss steht in DI.
                     rep stosb          ; Schleife bis CX (Lnge) = 0.
                     ret                ; Rcksprung.
        HoLine       endp
;
; ***************************************************************************
; Titel       : VeLine          
;
; Beschreibung: Zeichnet eine vertikale Linie in der Auflsung 320*200-256
;
; Aufruf      : AL = Farbe
;               BX = XPos
;               CX = relative Lnge
;               DX = YPos
;
; Ergebniss   : keines
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;
        VeLine       proc uses cx di
                     imul di,dx,320     ; Index berechnen,
                     add di,bx          ; Ergebniss steht in DI.
                VL1: mov screen:[di],al ; Farbe an Adresse speichern.
                     add di,320         ; Nchste Adresse berechnen.
                     loop VL1           ; Schleife bis CX (Lnge) = 0.
                     ret                ; Rcksprung.
        VeLine       endp
;
; ***************************************************************************
; Titel       : Line          
;
; Beschreibung: Zeichnet eine beliebige Linie in der Auflsung 320*200-256
;
; Aufruf      : AX = XPos1
;               BX = YPos1
;               CX = XPos2
;               DX = YPos2
;               SI = Farbe
;
; Ergebniss   : keines
;
; Seiteneffekt: keiner
;
; Anmerkung   : screen segment at 0a000h, assume es:screen 
;
  Line  proc uses ax bx cx dx di
        .if (ax == cx) && (bx == dx)    ; Prfen ob x1 = x2 und y1 = y2,
            imul di,bx,320              ; wenn ja, Index errechnen,
            add di,ax                   ; Index errechnen,
            xchg cx,si                  ; Farbe nach CX bertragen.
            mov screen:[di],cl          ; Punkt setzen.
            xchg cx,si                  ; Farbe wieder nach SI bertragen.
            ret                         ; Rcksprung.
        .endif
        .if ax > cx                     ; Prfen ob x1 > x2, wenn ja,
            xchg ax,cx                  ; x1 mit x2 und y1 mit y2
            xchg bx,dx                  ; vertauschen.
        .endif
        mov Help1,cx                    ; Steigung berechnen,
        sub Help1,ax                    ; (x2-x1 und y2-y1).
        mov Help2,dx
        sub Help2,bx
        push si                         ; SI sichern.
        mov si,Help2                    ; Help2 (y2-y1) nach SI und
        mov di,si                       ; di bertragen und SI negieren
        neg si                          ; bzw. negativ machen.
        .if (Help1 < si) && (sword ptr di < 0) ; Fall 1 "Steigung <-1":
            neg bx                             ; Gerade an der x-Achse
            neg dx                             ; und an der Winkel-
            xchg ax,bx                         ; halbierenden spiegeln.
            xchg cx,dx                     
        .elseif (Help1 >= si) && (sword ptr di < 0) ; Fall 2 "Steigung >= -1
            neg bx                                  ; und <= 0": Gerade an
            neg dx                                  ; der x-Achse spiegeln.
        .elseif (Help1 <= di) && (sword ptr di > 0) ; Fall 3 "Steigung >= 1":
            xchg ax,bx                              ; Gerade an der Winkel-
            xchg cx,dx                              ; halbierenden spiegeln.
        .endif                                
        pop si
        mov Help3,cx                                ; Neue Steigung berechnen
        sub Help3,ax                     
        mov Help4,dx
        sub Help4,bx
        push ax                              ; Mit der neuen Steigung,
        push bx                              ; restliche Konstante berechnen.
        mov ax,Help3                       
        mov bx,Help4
        shl Help4,1
        push Help4
        pop Help5
        sub Help4,ax
        sub bx,ax
        shl bx,1
        mov Help3,bx
        pop bx
        pop ax
        mov dx,ax                            ; Ersten Punkt setzen.
        call Li
        inc dx                               ; Restliche Punkte setzen.
        .repeat
            .if Help4 < 0
                mov ax,Help5
                add Help4,ax
            .else
                mov ax,Help3
                add Help4,ax
                inc bx
            .endif
             call Li
             inc dx
        .until sword ptr dx > cx
        ret                                  ; Rcksprung
  Line  endp

        Li  Proc uses bx dx      ; Procedur von Line zum setzen eines Pixels.
            mov ax,Help2
            neg ax
            .if (Help1 < ax) && (Help2 < 0)
                neg dx
                xchg bx,dx
            .elseif (Help1 >= ax) && (Help2 < 0)
                neg bx
            .endif
            mov ax,Help2
            .if (Help1 <= ax) && (sword ptr ax > 0)
                xchg bx,dx
            .endif
            imul di,bx,320
            add di,dx
            xchg cx,si
            mov screen:[di],cl
            xchg cx,si
            ret
        Li  endp   
;
; ***************************************************************************

end Start
